#include <iostream>
#include "BTree.h"

//  BNode NX̃o֐

bool BNode::insert(int k, int d){
  if(k==key){        // k = key Ȃ
    
    data = d;        // ㏑
    return(false);   // }Ȃ̂ false

  }else if(k<key){   // k < key Ȃ

    bool result;     // }ꂽǂ̌ʂi[ϐ

    if(leftNode != 0){       // ̎} BNode ݂
      result = leftNode->insert(k,d);
    }else{                   // ̎} BNode ݂Ȃ
      leftNode = new BNode(k,d);     //V BNode ǉ
      leftNode->parentNode = this;   //V BNode ̏ʂ
      result = true;                 // }ꂽ̂ true
    }

    return result;   // }ꂽǂ return

  }else{             // k > key Ȃ


    return(false);
    // ()  ͎ŋLqĂ
    //       L return(false) ̓_~[Ȃ̂, 폜Ă
    //       Lqĉ. 

  }

}


int BNode::find(int k){  // key=k Ȃ Node T, data Ԃ֐

   if(this==0){    //  Node ݂Ȃ (k|C^ł) Ȃ
     return(0);
   }else{
     if(key==k){        //  Node ߂ Node Ȃ
       return(data);
     }else if(k < key){ //  Node 荶 Node ߂ Node Ȃ
       return(leftNode->find(k));
     }else{             //  Node E Node ߂ Node Ȃ


        return(0);
       //  () ͎ŋLqĂ
       //      ́ureturn(0)v̓_~[Ȃ̂, ĂLqĉ

     }
   }
}

void BNode::PrintAll(void) const{
  if(this != 0){    //  Node ݂ (k|C^ł͂Ȃ)
    leftNode->PrintAll();    //  Node 荶̑SĂ Node ̃f[^\
    PrintLocal();            //  Node ̃f[^\
    rightNode->PrintAll();   //  Node ȆSĂ Node ̃f[^\
  }
}

void BNode::PrintLocal(void) const{

  std::cout << key << " " << data  << "\n";

}

//  BTree NX̃o֐

bool BTree::insert(int k, int d){

  if(root == 0){      // root m[h݂Ȃ

    root = new BNode(k,d);  // RXgN^ root m[h쐬
    iterator = root;        // Ce[^ root w
    bnodenum = 1;           // Sm[h 1
    return(true);           // }ꂽ̂ true

  }else{              // root m[h݂

    if(root->insert(k,d)){   // BNode  insert ֐Ăяo
       bnodenum++;           // ۂɑ}΃m[hꑝ
       return(true);         // }ꂽ̂ true
    }else{
       return(false);
    }

  }
}

int BTree::find(int k){   // key=k Ȃm[h data Ԃ

   return(root->find(k));  // root ɑ΂ find(k) Ăяo

}


void BTree::Print(void){

  root->PrintAll();
  
}


BNode* BTree::begin(void){   // ŏ key  Node Ԃ

  if(root==0){
    return 0;
  }else{
    BNode* bnd=root;
    
    while(bnd->leftNode != 0){
      bnd = bnd->leftNode;
    }
    return bnd;
  }
}

BNode* BTree::end(void){   // ő key  Node Ԃ

  if(root==0){
    return 0;
  }else{
    BNode* bnd=root;

    while(bnd->rightNode != 0){
      bnd = bnd->rightNode;
    }
    return bnd;
  }
}

const BNode* BTree::operator++(){  // Ce[^ړ
  
  iterate_iterator(iterator->key);

  return(iterator);

}

void BTree::iterate_iterator(int k){

  // Ɉړꍇ

  if(iterator==0){
    return;
  }else if(iterator->leftNode  != 0 && iterator->leftNode->key > k){
    iterator = iterator->leftNode;
    if(iterator->leftNode==0){
      return;
    }else{
      iterate_iterator(k);
      return;
    }
  }else if(iterator->rightNode  != 0 && iterator->rightNode->key > k){
    iterator = iterator->rightNode;
    if(iterator->leftNode==0){
      return;
    }else{
      iterate_iterator(k);
      return;
    }	
  }

   // Ɉړ, Hčsꍇ

  if(iterator->parentNode == 0){
    iterator = 0;
    return;
  }else{
    iterator = iterator->parentNode;

    if(iterator->key > k){
      return;
    }else{
      iterate_iterator(k);
      return;
    }
  }
}

