class BNode{

 private:
  BNode* parentNode;    // ʂ Node
  BNode* leftNode;      //  Node
  BNode* rightNode;     // E Node
  
  int key;
  int data;

 public:
  // RXgN^B|C^̓k|C^ŏ
  BNode(int k=0, int d=0) 
    : parentNode(0), leftNode(0),rightNode(0), key(k), data(d){ } 

  // fXgN^
  ~BNode(){ delete leftNode;  delete rightNode; }

  // key=k, data=d  Node  Tree ɉ
  bool insert(int k, int d);

  // Tree  key=k  Node A Node  data ^[
  int find(int k);

  //  Node  data ^[
  int getData(void) const { return data; }

  //  Node 牺̃f[^SăR\[ɕ\
  void PrintAll(void) const;

  //  Node ݂̂̃f[^R\[ɕ\
  void PrintLocal(void) const;

  friend class BTree; //BTree NXABNode NX private o
                      //ANZXł (thNX)
};


class BTree{

 private:
  BNode* root;         // Tree ̍ŏʂɗ Node
  BNode* iterator;     // Ce[^̐U͕킷|C^

  int bnodenum;        // Tree ̑S Node 

  BNode* begin(void);  // ł key  Node Ԃ
  BNode* end(void);    // ł傫 key  Node Ԃ

 public:
  BTree(void) : root(0), iterator(0){}  //RXgN^
  ~BTree(){ delete root; }              //fXgN^

  const BNode* Itr(void){ return iterator; }   //Ce[^^[
  int nodeNum(void){ return(bnodenum); } // S Node ^[

  bool insert(int k, int d);   // Tree ɁAkey=k, data=d  Node 

  int find(int k);     // key=k  Node Adata ^[

  const BNode* operator++();  // Ce[^̈ړ

  void iterate_iterator(int k);  // Ce[^̈ړ̎

   // Ce[^ŏ key  Node Ɉړ
  void setItrBegin(){ iterator = begin(); }

   // Ce[^ő key  Node Ɉړ
  void setItrEnd(){ iterator = end(); }

   // Ce[^̈ʒu bnd ɓǂ`FbN
  bool ItrEqual(BNode* bnd){
    if(iterator==bnd){
      return(true);
    }else{
      return(false);
    }
  }

   // Tree ̑SĂ Node  data ʂɕ\
  void Print(void);

};
